routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\AgentController;
use App\Http\Controllers\AnnouncementController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
// display list of announcement 
Route::get('/', [App\Http\Controllers\AnnouncementController::class, 'list'])->name('home');

//add the resource route of Agent
Route::resource("agents", AgentController::class);

//add the ressource route of announcement
Route::resource("announcements", AnnouncementController::class);

app/Models/Agent.php
<?php

namespace App\Models;

use App\Models\Announcement;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;

class Agent extends Model
{
    use HasFactory;
    protected $fillable = [ "firstName", "lastName" ];

    // Get the announcements for the Agent.
    public function announcements()
    {
        return $this->hasMany(Announcement::class);
    }
}

app/Http/Controllers/AgentController.php
<?php

namespace App\Http\Controllers;

use App\Models\Agent;
use Illuminate\Http\Request;

class AgentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //get all agents 
        $agents = Agent::latest()->get();
        //transmit agents to the view
        return view("agent.index", compact("agents"));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view("agent.edit");
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
         //  1.validation of the form
        $this->validate($request, [
            'firstName' => 'bail|required',
            "lastName" => 'bail|required'
        ]);

        // 2.add agent in database
        Agent::create([
            "firstName" => ucfirst($request->firstName),
            "lastName" => strtoupper($request->lastName)
        ]);

        // 3.redirect to index page and get message success
        return redirect(route('agents.index'))->with('success','Agent a bien été ajouté');
        

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Agent  $agent
     * @return \Illuminate\Http\Response
     */
    public function edit(Agent $agent)
    {
        return view("agent.edit", compact("agent"));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Agent  $agent
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Agent $agent)
    {
        // 1.validation 
        $rules = [
            "firstName" => 'bail|required',
            "lastName" => 'bail|required'
        ];
        $this->validate($request, $rules);

        // 2.update the agent information
        $agent->update([
            "firstName" => $request->firstName,
            "lastName" => $request->lastName
        ]);

        // 3.redirect to index page
        return redirect(route("agents.index"));

    }
    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Agent  $agent
     * @return \Illuminate\Http\Response
     */
    public function destroy(Agent $agent)
    {
    //delete the agent
        $agent->delete();
    // Redirection to "agents.index"
        return redirect(route('agents.index'));
    }
}

resources/views/agent/edit.blade.php
@extends('base')
@section("title","edit")
@section('content')
    <!-- if we have agent -->
	@if (isset($agent))
    <!-- the form is managed by the route "agents.update" -->
	<form method="POST" action="{{ route('agents.update', $agent) }}">
        <input type="hidden" name="_method" value="PUT">
    @else 
    <!-- the form is managed by the route "agents.store" -->  
    <form method="POST" action="{{ route('agents.store') }}">
    @endif
    @csrf
    
    <p>
        <label for="lastName" >Nom</label><br/>
        <!-- if we have $agent->lastName, we complete the input value -->
        <input type="text" name="lastName" 
            value="{{ isset($agent->lastName) ? $agent->lastName : old('lastName') }}" 
            id="lastName" placeholder="Nom"
        >
        <!-- error message -->
        @error("lastName")
        <div>{{ $message }}</div>
        @enderror
    </p>
    <p>
        <label for="firstName" >Prénom</label><br/>
        <!-- if we have $agent->firstName, we complete the input value -->
        <input type="text" name="firstName" 
            value="{{ isset($agent->firstName) ? $agent->firstName : old('firstName') }}"  
            id="firstName" placeholder="Prénom"
        >
        <!-- error message -->
        @error("firstName")
        <div>{{ $message }}</div>
        @enderror
    </p>
        <button type="submit" class="btn btn-success"><i class="fas fa-check"></i> Valider </button>
    </form>
@endsection

resources/views/agent/index.blade.php
@extends('base')
@section("title","index")
@section('content')
{{-- {{dump($agents)}} --}}
	<!-- The table to display the agents list -->
    </p>   
	<div class="table-responsive">
        <table class="table">
            <thead class="thead-dark">
                <tr>
                    <th>Nom </th>
                    <th>Prénom </th>
                    <th>Editer</th>
                    <th>Supprimer</th>
                </tr>
            </thead>
            <tbody>
			<!-- We browse the collection of agent  -->
			@foreach ($agents as $agent)
                <tr>
                    <td>{{ $agent->lastName }}</td>
                    <td>{{ $agent->firstName }}</td>
                    <td>
					<!-- Link to edit agent -->
                        <a href="{{ route('agents.edit', $agent) }}" 
                            title="edit the agent" ><i class="fas fa-edit fa-2x"></i>
                        </a>
                    </td>
                    <td>
					<!-- The form to delete agent-->
                        <form method="POST" action="{{ route('agents.destroy', $agent) }}" 
                            onsubmit="return confirm('Êtes-vous sûr de vouloir supprimer ?');"
                        >
                            <input type="hidden" name="_method" value="DELETE">
                            @csrf
                            <button class="btn btn-outline-danger"><i class="fas fa-trash-alt fa-2x"></i></button>
                        </form>																								
                    </td>
                </tr>
			@endforeach
            </tbody>
        </table>
    </div>
    <div>
        <a href="{{ route('agents.create') }}">
            <button class="btn btn-success offset-mr-5">
                <i class="fas fa-plus"></i> 
                    Ajouter un agent immobilier
            </button>
        </a>
    </div>	
@endsection